package interpreteur.interfaces;

import interpreteur.parser.Interpreteur;
import interpreteur.logique.Context;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;

public class InterfaceLigneDeCommandes
{

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        Context context = new Context();
        String input = "exit";
        BufferedReader reader = new BufferedReader(
                new InputStreamReader(System.in));
        Interpreteur interpreteur = new Interpreteur();

        // On regarde les paramètres de la ligne de commandes
        for (int i = 0; i < args.length; ++i)
        {
            if (args[i].equals("-debug"))
            {
                interpreteur.setDebug(true);
            }
        }

        System.out.println("Interpréteur d'expressions");
        System.out.println(" (c) François BIOLLET, Guillaume DELHUMEAU, Loïc GEFFROY");
        System.out.println("     Licence BSD");
        System.out.println(" - tappez 'exit' pour quitter\n");

        boolean run = true;
        do
        {
            try
            {
                System.out.print(">>> ");
                input = reader.readLine();
                if (input.equals("exit"))
                {
                    run = false;
                }
                else if (input.equals("debug=on"))
                {
                    interpreteur.setDebug(true);
                }
                else if (input.equals("debug=off"))
                {
                    interpreteur.setDebug(false);
                }
								else if (input.equals("context"))
                {
                    System.out.println(context + "\n");
                }
                else
                {
                    String out = interpreteur.analyse(input, context);
                    System.out.println(out + "\n");
                }

            }
            catch (IOException ex)
            {
                Logger.getLogger(
                        InterfaceLigneDeCommandes.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        while (run);
    }
}
