/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package interpreteur.logique;

import interpreteur.logique.resultats.InvalidInstruction;
import interpreteur.logique.resultats.Resultat;

/**
 *
 * @author Admin
 */
public class Reference extends ExpressionTerminale
{

    private String nom;
    private Resultat valeur;

    public Reference(String nom, Resultat valeur)
    {
        this.nom = nom;
        this.valeur = valeur;
    }

    public String getNom()
    {
        return nom;
    }

    public void setNom(String nom)
    {
        this.nom = nom;
    }

    public Resultat getValeur()
    {
        return valeur;
    }

    public void setValeur(Resultat valeur)
    {
        this.valeur = valeur;
    }

    @Override
    public Resultat interprete(Context c) throws InvalidInstruction
    {
        try
        {
            return c.getReference(nom).getValeur();
        }
        catch (NullPointerException e)
        {
            throw new InvalidInstruction("La variable " + nom + " n'existe pas.");
        }
    }

    @Override
    public boolean isCompleteAgauche()
    {
        return true;
    }

    @Override
    public boolean isCompleteAdroite()
    {
        return true;
    }

    @Override
    public void setGauche(ExpressionAbstraite e)
    {
        return;
    }

    @Override
    public void setDroite(ExpressionAbstraite e)
    {
        return;
    }

    @Override
    public int getPriorite()
    {
        return 0;
    }

    @Override
    public String toString()
    {
        return nom;
    }
}
