/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package interpreteur.logique.expressions.terminales;

import interpreteur.logique.Context;
import interpreteur.logique.ExpressionAbstraite;
import interpreteur.logique.ExpressionTerminale;
import interpreteur.logique.Reference;
import interpreteur.logique.resultats.InvalidInstruction;
import interpreteur.logique.resultats.Resultat;
import interpreteur.logique.resultats.ResultatDouble;
import interpreteur.logique.resultats.ResultatVide;

/**
 *
 * @author Admin
 */
public class Affectation extends ExpressionTerminale
{

    private String nomRef;
    private ExpressionAbstraite valeur;

    public Affectation(String nomRef, ExpressionAbstraite valeur)
    {
        this.nomRef = nomRef;
        this.valeur = valeur;
        priorite = 0;
    }

    public String getNomRef()
    {
        return nomRef;
    }

    public void setNomRef(String nomRef)
    {
        this.nomRef = nomRef;
    }

    public ExpressionAbstraite getValeur()
    {
        return valeur;
    }

    public void setValeur(ExpressionAbstraite valeur)
    {
        this.valeur = valeur;
    }

    @Override
    public Resultat interprete(Context c) throws InvalidInstruction
    {
        Reference ref = c.addReference(nomRef);
        ref.setValeur(valeur.interprete(c));
        //return ref.getValeur();
				return new ResultatVide();
    }

    @Override
    public boolean isCompleteAgauche()
    {
        return nomRef != null;
    }

    @Override
    public boolean isCompleteAdroite()
    {
        return valeur != null;
    }

    @Override
    public void setGauche(ExpressionAbstraite e) throws InvalidInstruction
    {
        if (e instanceof Reference)
        {
            Reference ref = (Reference) e;
            nomRef = ref.getNom();
        }
        else
        {
            throw new InvalidInstruction("Affectation non valide.");
        }
        
    }

    @Override
    public void setDroite(ExpressionAbstraite e)
    {
        valeur = e;
    }

    @Override
    public String toString()
    {
        return "aff(" + nomRef + " = " + valeur + ")";
    }
}
