/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package interpreteur.logique.expressions.terminales;

import interpreteur.logique.Context;
import interpreteur.logique.ExpressionAbstraite;
import interpreteur.logique.expressions.nonterminales.TermeLogique;
import interpreteur.logique.resultats.InvalidInstruction;
import interpreteur.logique.resultats.Resultat;
import interpreteur.logique.resultats.ResultatBooleen;

/**
 *
 * @author Admin
 */
public class Inferieur extends TermeLogique
{

	private ExpressionAbstraite gauche;
	private ExpressionAbstraite droite;

	public Inferieur(ExpressionAbstraite gauche, ExpressionAbstraite droite)
	{
		this.gauche = gauche;
		this.droite = droite;
        priorite = 1;
	}

	public ExpressionAbstraite getDroite()
	{
		return droite;
	}

	public void setDroite(ExpressionAbstraite droite)
	{
		this.droite = droite;
	}

	public ExpressionAbstraite getGauche()
	{
		return gauche;
	}

	public void setGauche(ExpressionAbstraite gauche)
	{
		this.gauche = gauche;
	}

	@Override
	public Resultat interprete(Context c) throws InvalidInstruction
	{
		return new ResultatBooleen(gauche.interprete(c).toDouble() <=
						droite.interprete(c).toDouble());
	}

	@Override
	public boolean isCompleteAgauche()
	{
		return gauche != null;
	}

	@Override
	public boolean isCompleteAdroite()
	{
		return droite != null;
	}

	@Override
	public String toString()
	{
		return "(" + gauche + "<=" + droite + ")";
	}
}
