package interpreteur.logique.expressions.terminales;

import interpreteur.logique.Context;
import interpreteur.logique.ExpressionAbstraite;
import interpreteur.logique.expressions.nonterminales.ExpressionLogique;
import interpreteur.logique.expressions.nonterminales.TermeLogique;
import interpreteur.logique.resultats.Resultat;
import interpreteur.logique.resultats.ResultatBooleen;
import interpreteur.logique.resultats.InvalidInstruction;

public class Non extends TermeLogique
{

    public Non(ExpressionLogique exp)
    {
        super();
        this.expression = exp;
        priorite = 1;
    }

    @Override
    public Resultat interprete(Context c) throws InvalidInstruction
    {
        Resultat r = expression.interprete(c);
        return new ResultatBooleen(!r.toBoolean());
    }

    @Override
    public boolean isCompleteAgauche()
    {
        return true;
    }

    @Override
    public boolean isCompleteAdroite()
    {
        return expression != null;
    }

    @Override
    public void setGauche(ExpressionAbstraite e)
    {
        return;
    }

    @Override
    public void setDroite(ExpressionAbstraite e)
    {
        expression = e;
    }

}
