package interpreteur.parser;

import interpreteur.parser.grammatical.ParserGrammatical;
import interpreteur.parser.lexical.MotLexical;
import interpreteur.parser.lexical.ParserLexical;
import interpreteur.logique.Context;
import interpreteur.logique.ExpressionAbstraite;
import interpreteur.logique.resultats.InvalidInstruction;
import interpreteur.logique.resultats.Resultat;
import java.util.ArrayList;

/**
 *
 * @author Admin
 */
public class Interpreteur {

    private boolean debug;

    public Interpreteur()
    {
        debug = false;
    }

    public String analyse(String input, Context context) {
        try {
            String reponse = new String();
            input = input.replaceAll(" ", "") + ParserLexical.FIN_INSTRUCTION;
            ParserLexical lex = new ParserLexical();
            lex.setDebug(debug);
            ArrayList<MotLexical> sequence = lex.analyse(input);
            ParserGrammatical gram = new ParserGrammatical();
            gram.setDebug(debug);
            ExpressionAbstraite exp = gram.analyse(sequence);
						if(debug)
						{
							System.out.println("== Interprétation du calul ==");
						}
            Resultat r = exp.interprete(context);
            reponse = r.toString();
            return reponse;
        } catch (SyntaxException ex) {
            return "! Erreur : " + ex.getMessage();
        } catch (InvalidInstruction ex) {
            return "! Erreur : " + ex.getMessage();
        }
    }

    public boolean isDebug() {
        return debug;
    }

    public void setDebug(boolean debug) {
        this.debug = debug;
    }


}
